;##################################################################
; DLLAPP
;##################################################################
#include "C:\GoAsm\IncludeA\WINDOWS.inc"
#include "C:\GoAsm\IncludeA\all_api.inc"

MAX_PLUGINS equ 16

// Dialogs
IDD_WEX_MAINDLG			equ	1000
IDD_WEX_SEARCH			equ 2000
IDD_WEX_PLUGINS			equ 3000
IDD_WEX_PROPS			equ 4000
IDD_WEX_REGDLG			equ	5000
IDD_WEX_REGITEM			equ	5500
IDD_WEX_WALLPAPER		equ 6000
IDD_WEX_DISKINFO		equ 6500
IDD_WEX_PROCINFO		equ 7000
IDD_WEX_DLLINFO			equ 7500

// Toolbar preset commands
CMD_OK				equ	1
CMD_CANCEL			equ	2
CMD_HELP			equ	5000
CMD_RUN				equ	5001
CMD_FINDFILE		equ	5002
CMD_CONSOLE			equ	5003
CMD_PROCESS			equ	5004
CMD_REGEDIT			equ	5005
CMD_MYDOCS			equ 5006
CMD_CPU				equ 5007
CMD_FAV				equ 5008
CMD_PLUGIN			equ 5009
CMD_SETTIME			equ 5010
CMD_HEXVIEW			equ 5011
CMD_LAST			equ CMD_HEXVIEW

// Listview menu
IDR_LVMENU			equ 10000
IDM_OPEN			equ 600
IDM_ARRANGE			equ 601
IDM_INFO			equ 602
IDM_OPENINCMD		equ 603
IDM_PROPS			equ 604
IDM_LINK			equ 605
IDM_OPENDBG			equ 606
IDM_OPENAS			equ	607
IDM_SETWP			equ	608
IDM_SHEX			equ 609
IDM_SHIMP			equ 610
IDM_SHCONT			equ 611

WEXPLUGINS STRUCT
	cbPlugIns			DD	?
	hPlugInList			DD	?
	// There are a maximum of 16 PlugIns
	PlugInHandles		DD	MAX_PLUGINS DUP (?)
	PlugInProcs			DD	MAX_PLUGINS DUP (?)
	PlugInData			DD	MAX_PLUGINS DUP (?)
	PlugInpNames		DD	MAX_PLUGINS DUP (?)
	PlugInpDesc			DD	MAX_PLUGINS DUP (?)
ENDS

WEXHANDLES STRUCT
	cbHandles			DD	?
	hInstance			DD 	?
	hWinExplorer		DD	?
	hStatusBar			DD	?
	hSplitter			DD	?
	hTreeView			DD	?
	hListView			DD	?
	hToolbar			DD	?
	hHeader				DD	?
	hImlTreeView		DD	?
	hDivBar				DD	?
	hSysImlLarge		DD	?
	hSysImlSmall		DD	?
	hExportListview		DD	?
	hImportTreeview		DD	?
	hImlToolbar			DD	?
	hIcon				DD	?
	hPropIconLarge		DD	?
	hPropIconSmall		DD	?
	hFont				DD	?
	hProcessHeap		DD	?
	hTab				DD	?
	hTabDlg				DD	4 DUP (?)
	SelTab				DD	?
ENDS

WEXFLAGS STRUCT
	cbFlags				DD ?

	fMainTVLock			DD ?
	TreeViewRatio		DD ? ; Do not modify !!
	MainIsMoving		DD ? ; Do not modify !!
	MainIsSizing		DD ? ; Do not modify !!
	fMainAdjust			DD ? ; Do not modify !!

	fRegTVLock			DD ?
	RegTreeViewRatio	DD ? ; Do not modify !!
	RegIsSizing			DD ? ; Do not modify !!
	RegIsMoving			DD ? ; Do not modify !!

	f9x					DD ? ; Do not modify !!
	NextCmdID			DD ?
ENDS

WEXPROCS STRUCT
	cbProcs					DD ?
	pIsFunctionAvailable	DD ?
	pGetCRC					DD ?
	pGetMD5Hash				DD ?
	pszLen					DD ?
	pszCat					DD ?
	pszCopy					DD ?
	pszCmpi					DD ?
	pIsPEFile				DD ?
	pIsShortcut				DD ?
	pGetFileExists			DD ?
	pStripFilename			DD ?
	pdw2ascii				DD ?
	pdq2ascii				DD ?
	pdw2hex					DD ?
	pdq2hex					DD ?
	pFpuFLtoA				DD ?
	pmemcopy				DD ?
	phItemToPath			DD ?
	pPathTohItem			DD ?
	pGetLinkInfoIndirect	DD ?
	pTreeView_GetItemRoot	DD ?
	pTreeViewFindItem		DD ?
	pListViewGetPath		DD ?
	pAddToolbarButton		DD ?
	pSubClassEdit			DD ?
	pSubClassEdit2			DD ?
	pGetExtension			DD ?
ENDS

#Define WM_APP 8000h

// PlugIn flags
WEX_MUSTUNLOAD equ 1 ; The plugin will be freed regardless of return value, lParam of PIN_UNLOADNOW

// PlugIn notifications
// These messages are sent to the Plugins by WinExplorer
// Return PIR_STOP to stop processing. PIR_CONT to continue
PIN_FIRST equ WM_APP
PIN_UNLOADNOW	equ	PIN_FIRST   ; The PlugIn is about to be freed - lParam = NULL/WEX_MUSTUNLOAD
PIN_DLGINIT	equ	PIN_FIRST+1 ; A dialog is about to display - wParam = Handle of the dialog, lParam = ID of the dialog
PIN_MENUSELECT equ PIN_FIRST+2 ; wParam = Command ID, lParam = Pointer to selected text
PIN_MENUINIT equ PIN_FIRST+4 ; A context menu is about to be displayed, wParam = Menu Handle, lParam = Parent ID
PIN_COMMAND equ PIN_FIRST+8 ; wParam = hwnd, lParam = Command ID
PIN_MENUCMD equ PIN_FIRST+16 ; wParam = Child ID, lParam = Command ID
PIN_NOTIFY	equ PIN_FIRST+32 ; wParam = hwnd, lParam = pNMHDR - Return value ignored
PIN_CONTEXTMENU equ PIN_FIRST+64 ; See WM_CONTEXTMENU - Returning PIR_STOP will stop menu displaying
PIN_HELP equ PIN_FIRST+128 ; See WM_HELP - Returning PIR_STOP will stop About dialog from displaying
PIN_PLUGINSLOADED equ PIN_FIRST+256 ; Sent after all plugins are loaded, lParam = # of plugins
PIN_TABINIT equ PIN_FIRST+512 ; hwnd = Handle of the TAB, lParam = ID of the tab
PIN_LVDBLCLICK equ PIN_FIRST+1024 ; hwnd = Handle of the listview, wParam = listview item #, lParam = pointer to selected file name

// PlugIn messages
// These messages are sent from the PlugIns to WinExplorer
PIM_FIRST equ WM_APP+8192
PIM_GETHANDLES	equ	PIM_FIRST
PIM_GETFLAGS	equ	PIM_FIRST+1
PIM_GETPROCS	equ	PIM_FIRST+2
PIM_GETCTRLID	equ	PIM_FIRST+3
PIM_GETPLUGINS	equ	PIM_FIRST+4

// PlugIn replies
// These replies are sent from the PlugIns to WinExplorer
// or generated internally by WinExplorer based on runtime criteria
PIR_NOPLUGIN	equ -1 ; No plugin was found at the index specified
PIR_CONT		equ 0
PIR_STOP		equ 1
PIR_CANTUNLOAD 	equ	2 ; A plugin refused to/could not unload
PIR_FIRST		equ 4

IPicture STRUCT
	; IUnknown methods
	QueryInterface			DD
	AddRef					DD
	Release					DD
	; IPicture methods
	get_Handle				DD
	get_hPal				DD
	get_Type				DD
	get_Width				DD
	get_Height				DD
	Render					DD
	set_hPal				DD
	get_CurDC				DD
	SelectPicture			DD
	get_KeepOriginalFormat	DD
	put_KeepOriginalFormat	DD
	PictureChanged			DD
	SaveAsFile				DD
	get_Attributes			DD
IPicture ENDS

#define HIMETRIC_INCH 2540
#define GUID_IID_IPicture <07BF80980H, 0BF32H, 0101AH, 08BH, 0BBH, 000H, 0AAH, 000H, 030H, 00CH, 0ABH>

DATA SECTION
	hInstance		DD		0
	pProcs			DD		0
	pHandles		DD		0
	Wex1Cmd			DD		0
	hMain			DD		0
	hStatic			DD		0
	IID_IPicture	GUID	GUID_IID_IPicture

	ClassName	DB	"JpgViewerClass",0
	AppName		DB	"JPG Viewer",0

CODE SECTION

	PlugInName: DB "TestPlugIn",0
	PlugInDesc:	DB "This is a test",0

DllEntryPoint	FRAME hInst, reason, reserved1

	mov eax,[reason]
	.DLLPROCESSATTACH
	cmp eax,DLL_PROCESS_ATTACH
	JNE >.DLLPROCESSDETACH
		mov eax,[hInst]
		mov [hInstance], eax
		JMP >.LOAD
	
	.DLLPROCESSDETACH
	cmp eax,DLL_PROCESS_DETACH
	JNE >.DLLTHREADATTACH
		JMP >.LOAD
	
	.DLLTHREADATTACH
	cmp eax,DLL_THREAD_ATTACH
	JNE >.DLLTHREADDETACH
		JMP >.LOAD
	
	.DLLTHREADDETACH
	cmp eax,DLL_THREAD_DETACH
	JNE >.NOLOAD
		JMP >.LOAD
	
	.NOLOAD
		; The reson was not understood
		; Rather than take a chance we will refuse to load
		xor eax, eax
		ret
	
	.LOAD
		xor eax, eax
		inc eax

	ret
ENDF

InitPlugIn FRAME hwnd,lParam

	invoke SendMessage,[hwnd],PIM_GETPROCS,0,0
	mov [pProcs],eax

	invoke SendMessage,[hwnd],PIM_GETHANDLES,0,0
	mov [pHandles],eax

	mov eax,PIN_LVDBLCLICK | PIN_MENUSELECT
	RET
ENDF

PlugInProc FRAME hwnd,uMsg,wParam,lParam
	
	cmp D[uMsg], PIN_LVDBLCLICK
	jne >
		invoke DisplayJPG,[lParam]
		ret

	:
	cmp D[uMsg], PIN_MENUSELECT
	jne >>.EXIT
		mov eax,[hwnd]
		mov edx,[pHandles]
		cmp [edx+WEXHANDLES.hListView],eax
		jne >>.EXIT
		cmp D[wParam],IDM_OPEN
		jne >>.EXIT
			invoke DisplayJPG,[lParam]
			ret

	.EXIT

	mov eax,PIR_CONT
	RET
ENDF

DisplayJPG FRAME pszFile
	uses edi
	LOCAL ext[16]	:B
	
	mov edi,[pProcs]
	invoke [edi+WEXPROCS.pGetExtension],[pszFile],offset ext

	invoke [edi+WEXPROCS.pszCmpi],offset ext,".jpg"
	test eax,eax
	jnz >>.EXITCONT

	invoke WinMain,[hInstance],NULL,[pszFile],SW_SHOW

	mov eax,PIR_STOP
	RET

	.EXITCONT
	mov eax,PIR_CONT
	RET

ENDF

WinMain FRAME hInst,hPrevInst,CmdLine,CmdShow
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL rect:RECT

	mov D[wc.cbSize],SIZEOF WNDCLASSEX
	mov D[wc.style], CS_HREDRAW + CS_VREDRAW
	mov [wc.lpfnWndProc], OFFSET WndProc
	mov D[wc.cbClsExtra],NULL
	mov D[wc.cbWndExtra],NULL
	push [hInstance]
	pop [wc.hInstance]
	mov D[wc.hbrBackground],COLOR_BTNFACE+1
	mov D[wc.lpszMenuName],NULL
	mov [wc.lpszClassName],OFFSET ClassName

	invoke LoadIcon,NULL,IDI_APPLICATION
	mov [wc.hIcon],eax
	mov [wc.hIconSm],eax

	invoke LoadCursor,NULL,IDC_ARROW
	mov [wc.hCursor],eax

	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
			WS_OVERLAPPED+WS_CAPTION+WS_SYSMENU+WS_THICKFRAME,CW_USEDEFAULT,\
			CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
			[hInst],NULL

	mov [hMain],eax

	invoke GetClientRect,[hMain],offset rect
	invoke CreateWindowEx,WS_EX_STATICEDGE,"STATIC","TEST1",WS_CHILD + WS_VISIBLE + SS_BITMAP,0,0,[rect.right],[rect.bottom],[hMain],1001,[hInst],NULL
	mov [hStatic],eax

	invoke ShowWindow, [hMain],[CmdShow]
	invoke UpdateWindow, [hMain]

	invoke PostMessage,[hMain],WM_USER,0,[CmdLine]

	:
		invoke GetMessage, ADDR msg,NULL,0,0
		test eax,eax
		jz >
			invoke IsDialogMessage, [hMain], ADDR msg
			test eax,eax
			jnz <
				invoke TranslateMessage, ADDR msg
				invoke DispatchMessage, ADDR msg
				jmp <
	:

	mov eax,[msg.wParam]
	ret
ENDF

WndProc FRAME hWnd, uMsg, wParam, lParam
	LOCAL hBitmap	:D
	LOCAL bmp		:BITMAP
	LOCAL rect		:RECT

	.WMCREATE
	cmp D[uMsg],WM_CREATE
	jne >>.WMUSER
		jmp >>.EXIT

	.WMUSER
	cmp D[uMsg],WM_USER
	jne >>.WMCLOSE
		invoke LoadPicture,[lParam]
		mov [hBitmap],eax
		
		// Resize the window to the bitmap
		invoke GetObject,[hBitmap],SIZEOF BITMAP,offset bmp
		mov eax,[bmp.bmWidth]
		mov [rect.right],eax
		mov eax,[bmp.bmHeight]
		mov [rect.bottom],eax
		mov D[rect.left],0
		mov D[rect.top],0
		invoke AdjustWindowRect,offset rect,NULL,FALSE
		invoke SetWindowPos,[hWnd],0,0,0,[rect.right],[rect.bottom],SWP_NOMOVE + SWP_NOZORDER
		invoke GetClientRect,[hMain],offset rect
		invoke SetWindowPos,[hStatic],0,0,0,[rect.right],[rect.bottom],SWP_NOMOVE + SWP_NOZORDER
		invoke SendMessage,[hStatic],STM_SETIMAGE,IMAGE_BITMAP,[hBitmap]
		jmp >>.EXIT

	.WMCLOSE
	cmp D[uMsg],WM_CLOSE
	jne >>.WMDESTROY
		invoke SendMessage,[hStatic],STM_GETIMAGE,IMAGE_BITMAP,0
		invoke DeleteObject,eax
		invoke DestroyWindow,[hWnd]
		jmp >>.EXIT

	.WMDESTROY
	cmp D[uMsg],WM_DESTROY
	jne >>.DEFPROC
		invoke PostQuitMessage,NULL
		jmp >>.DEFPROC

	.DEFPROC
		invoke DefWindowProc,[hWnd],[uMsg],[wParam],[lParam]		
		ret

	.EXIT

	xor eax,eax
	ret
ENDF

LoadPicture FRAME pszPictureFile
	uses edi
	LOCAL pPicture					:D
	LOCAL hDC						:D
	LOCAL hTempDC					:D
	LOCAL OldObj					:D
	LOCAL hReturnBmp				:D
	LOCAL OLE_YSIZE_HIMETRIC		:D
	LOCAL OLE_XSIZE_HIMETRIC		:D
	LOCAL dwWidth					:D
	LOCAL dwHeight					:D
	LOCAL hPalette					:D
	LOCAL ptTop						:POINT
	LOCAL ptBtm						:POINT
	LOCAL cColors[256]				:D
	LOCAL dwNumColors				:D

	LOCAL pGlobal					:D
	LOCAL pStream					:D
	LOCAL hFile						:D
	LOCAL dwSize					:D
	LOCAL fsh						:D

	invoke CreateFile,[pszPictureFile],GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_ALWAYS,NULL,NULL
	mov [hFile],eax
	invoke GetFileSize,[hFile],ADDR fsh
	mov [dwSize],eax
	invoke GlobalAlloc,GMEM_FIXED,eax
	mov [pGlobal],eax
	invoke ReadFile,[hFile],[pGlobal],[dwSize],ADDR fsh,NULL
	invoke CloseHandle,[hFile]

	invoke CreateStreamOnHGlobal, [pGlobal], TRUE, ADDR pStream
	invoke OleLoadPicture, [pStream], NULL, TRUE, ADDR IID_IPicture, ADDR pPicture

	test eax,eax
	jz >
		; no interface
		invoke GlobalFree,[pGlobal]
		ret
	:

	mov edi, [pPicture]

	push OFFSET OLE_YSIZE_HIMETRIC
	push edi
	mov eax, [edi]
	call [eax+IPicture.get_Height]

	push OFFSET OLE_XSIZE_HIMETRIC
	push edi
	mov eax, [edi]
	call [eax+IPicture.get_Width]

	invoke GetDC,NULL
	mov [hDC],eax
	invoke CreateCompatibleDC,[hDC]
	mov [hTempDC],eax

	invoke GetDeviceCaps, [hDC], LOGPIXELSY
	invoke MulDiv, [OLE_YSIZE_HIMETRIC], eax, HIMETRIC_INCH
	mov [dwHeight], eax
	invoke GetDeviceCaps, [hDC], LOGPIXELSX
	invoke MulDiv, [OLE_XSIZE_HIMETRIC], eax, HIMETRIC_INCH
	mov [dwWidth], eax
	invoke CreateIndependantBitmap,[hDC],[dwWidth],[dwHeight]
	mov [hReturnBmp],eax
	invoke ReleaseDC,NULL,[hDC]
	invoke SelectObject,[hTempDC],[hReturnBmp]
	mov [OldObj],eax

;	push edi
;	mov eax, [edi]
;	call [eax+IPicture.get_Handle]

;	invoke ReduceBitCount,[hReturnBmp],8,ADDR cColors,FALSE
;	invoke SetDIBColorTable,[hTempDC],0,256,ADDR cColors

	xor ecx,ecx
	push ecx
	push [OLE_YSIZE_HIMETRIC]
	push [OLE_XSIZE_HIMETRIC]
	push ecx
	push ecx
	push [dwHeight]
	push [dwWidth]
	push ecx
	push ecx
	push [hTempDC]
	push edi
	mov eax, [edi]
	call [eax+IPicture.Render]

	; release the stream
	mov eax, [pStream]
	push eax
	mov eax, [eax]
	call [eax+IPicture.Release] 

	push edi
	mov eax, [edi]
	call [eax+IPicture.Release]
 
	; Flip the bitmap
	xor ecx,ecx
	mov eax,[dwWidth]
	mov D[ptBtm.x],eax
	mov D[ptTop.x],ecx
	mov eax,[dwHeight]
	dec eax
	mov D[ptTop.y],eax
	inc eax
	neg eax
	mov D[ptBtm.y],eax
	invoke StretchBlt, [hTempDC], ecx, ecx, [dwWidth], [dwHeight],\
		[hTempDC], [ptTop.x], [ptTop.y], [ptBtm.x],[ ptBtm.y], SRCCOPY

	invoke SelectObject,[hTempDC],[OldObj]
	invoke DeleteDC,[hTempDC]
	invoke GlobalFree,[pGlobal]
	mov eax,[hReturnBmp]
	ret

endf

CreateIndependantBitmap FRAME hDC,SizeX,SizeY
	LOCAL bmi			:BITMAPINFO

	mov D[bmi.bmiHeader.biSize],SIZEOF BITMAPINFOHEADER
	mov eax,[SizeX]
	mov D[bmi.bmiHeader.biWidth],eax
	mov eax,[SizeY]
	mov D[bmi.bmiHeader.biHeight],eax
	mov W[bmi.bmiHeader.biPlanes],1
	mov W[bmi.bmiHeader.biBitCount],32
	mov D[bmi.bmiHeader.biCompression],BI_RGB
	xor ecx,ecx
	invoke CreateDIBSection,[hDC],ADDR bmi,DIB_RGB_COLORS,ecx,ecx,ecx

	push eax
	invoke GdiFlush
	pop eax
	ret

endf
